% Sir Data Fixer
% This function remove the incomplete frames from files so that they can be
% processed using the logical indices

function newFilesize = fixSirFile(inputfile,framelen)

%create a copy of the input file first
file2fix = [inputfile,'-orig'];
copyfile(inputfile,file2fix);
%% Processing Flags
readsize = 260000000;
rdFile = fopen(file2fix,'r');
[rdData,dcount] = (fread(rdFile,readsize,'*uint8','b'));
ind1 = find(rdData == 255);
ind2 = find(rdData(ind1+1) == 255);
ind = ind1(ind2);
ind3 = find(rdData(ind + 2) == 255);
ind = ind(ind3);
ind4 = find(rdData(ind + 3) == 255);
ind = ind(ind4);
inddiff = diff(ind);

ind_good = ind(inddiff == framelen*2);
if  (dcount-ind(end) == framelen*2)
    ind_good = [ind_good ind(end)];
end
wrFile = fopen([inputfile],'w+');
clear rdData ind1 ind2 ind3 ind4
for pnum = 1:numel(ind_good)
    fseek(rdFile,(ind_good(pnum)-1),'bof');
    fwrite(wrFile,fread(rdFile,framelen,'*int16','b'),'int16','b');
end
fclose(wrFile);
fclose(rdFile);
finfo = dir(inputfile);
newFilesize = finfo.bytes;
fprintf('Removed %d bad frames\n',numel(ind) - numel(ind_good));
