% Sir Data Fixer
% This function remove the incomplete frames from files so that they can be
% processed using the logical indices
% Edited 17 Nov to inlcude while loop line 23-29

function newFilesize = fixSirFile_stacked(inputfile,framelen)

%create a copy of the input file first
if(nargin < 1)
    [filename,filepath] = uigetfile('*.*');
    inputfile = fullfile(filepath,filename);
end
if ~exist('framelen','var')
    framelen = 12474;
end
file2fix = [inputfile,'-orig']; 
copyfile(inputfile,file2fix);
%% Processing Flags
readsize = 260000000;
rdFile = fopen(file2fix,'r');
% rdFile = fopen(inputfile,'r');
[rdData,dcount] = (fread(rdFile,readsize,'*uint8'));
ind1 = find(rdData == 255);
while(1)
    if ind1(end)>(dcount-10)
        ind1=ind1(1:(end-1));
    else
        break
    end
end
ind2 = find(rdData(ind1 + 1) == 255);
ind = ind1(ind2);
ind3 = find(rdData(ind + 2) == 255);
ind = ind(ind3);
ind4 = find(rdData(ind + 3) == 255);
ind = ind(ind4);
ind5 = find(rdData(ind + 4) == 255);
ind = ind(ind5);
ind6 = find(rdData(ind + 5) == 255);
ind = ind(ind6);
ind7 = find(rdData(ind + 6) == 255);
ind = ind(ind7);
ind8 = find(rdData(ind + 7) == 255);
ind = ind(ind8);
inddiff = diff(ind);

ind_good = ind(inddiff == framelen*4);
if  (dcount-ind(end) == framelen*4)
    ind_good = [ind_good ind_good(end)];
end
wrFile = fopen([inputfile],'w+');
clear rdData ind1 ind2 ind3 ind4
for pnum = 1:numel(ind_good)
    fseek(rdFile,(ind_good(pnum)-1),'bof');
    fwrite(wrFile,fread(rdFile,framelen,'*int32','b'),'int32','b');
end
fclose(wrFile);
fclose(rdFile);
finfo = dir(inputfile);
newFilesize = finfo.bytes;
fprintf('Removed %d bad frames\n',numel(ind) - numel(ind_good));
