function [numFilesRestored] = restoreOrigSirFiles(inputfolder)

if(nargin<1)
    if usejava('desktop')
        inputfolder = uigetdir('Select SIR directory');
    else
        error('Requires path to sir data as argument')
    end
end
dfiles = dir(fullfile(inputfolder,'*.sir-orig'));
if isempty(dfiles)
    numFilesRestored = 0;
    fprintf('No files to restore\n');
    return;
end
fprintf('Restoring Original files in %s\n',inputfolder);
for jj = 1:numel(dfiles)
fprintf('File %d of %d\n',jj,numel(dfiles));
movefile([inputfolder,filesep,dfiles(jj).name],[inputfolder,filesep,dfiles(jj).name(1:end-5)]);
end
fprintf('Done!\n');
numFilesRestored = jj;
end